
#include "local.h"
#include <stdio.h>
#include <math.h>
#include "vec.h"
#include "mat.h"
#include "complex.h"

Mat_ptr M[3];
char prog_name[] = "mattest";

main()
{ char Ans;
  printf("\nTEST MATRIX ROUTINE");
  Ans='0';
  while (Ans!='Z' && Ans!='z')
  { printf("\n");
    printf("1) Open       2) Close      3) Init       4) Get\n");
    printf("5) Put        6) Move       7) Add        8) Sub\n");
    printf("9) Mult       a) Invert     b) Sadd       c) Ssub\n");
    printf("d) Smult      e) Display    f) Pntrs      g) Reduction\n");
    printf("h) Lud        i) Conj Grad\n");
    printf("Z) Quit\n");
    printf(" = ");
    while ( (Ans=getchar())<'0');
    printf("\n");
    switch(Ans)
    { case '1':XOpen(); break;  case '2':XClose(); break; 
      case '3':XInit(); break;  case '4':XGet(); break; 
      case '5':XPut(); break;   case '6':XMove(); break;
      case '7':XAdd(); break;   case '8':XSub(); break; 
      case '9':XMult(); break;  case 'a':XInvert(); break;
      case 'b':XSadd(); break;  case 'c':XSsub(); break; 
      case 'd':XSmult(); break; case 'e':Display(); break;
      case 'f':Print_ptrs(); break; case 'g':XRed(); break;
      case 'h':Xlud(); break;   case 'i':XGrad();  break;
    } /*switch*/
  } /*while*/
} /*main*/

#include "vec.c"
#include "nfvec.c"
#include "vecmove.c"
#include "vecchs.c"
#include "vecconj.c"
#include "vecadd.c"
#include "vecsadd.c"
#include "vecsub.c"
#include "vecssub.c"
#include "vecmult.c"
#include "vecsmult.c"
#include "vecdiv.c"
#include "vecsdiv.c"
#include "vecsum.c"
#include "vecdot.c"
/*#include "vecsqrt.c"
  #include "vecexp.c"
  #include "vecln.c"
  #include "vecsin.c"
  #include "veccos.c"
  #include "vectan.c"
  #include "vecasin.c"
  #include "vecacos.c"
  #include "vecatan.c"*/

#include "ssmat.c"
#include "mat.c"
#include "matmove.c"
#include "matcol.c"
#include "matasm.c"
#include "matinv.c"
#include "matred.c"

Print_ptrs()
{ int Nmat,i;
  printf("Which matrix (0-2, -1 to quit) = ");
  scanf("%d",&Nmat);
  if (Nmat<0 || Nmat>2) return;
  printf("Matrix location = %8ld",M[Nmat]);
  if (M[Nmat]!=NULL) for (i=0; i<M[Nmat]->Num_row; i++)
    printf("%sRow %d starts at %ld\n",i?"                           ":" ",i,M[Nmat]->Row[i]);
  printf("\n");
} /*Print_ptrs*/
  
Print_el(i,j,M)  int i,j;  Mat_ptr M;
{ printf("(%8f,%8f) ",Mat_get_re(i,j,M),Mat_get_im(i,j,M));
} /*Print_el*/

Print_mat(Nmat) int Nmat;
{ int Nrow,Ncol,Nr,Nc;
  if (M[Nmat]!=NULL)
  { Nr=M[Nmat]->Num_row;
    Nc=M[Nmat]->Num_col;
    Nc = (Nc<8) ? Nc : 7 ;
    for (Nrow=0; Nrow<Nr; Nrow++)
    { printf("\n");
      for (Ncol=0; Ncol<Nc; Ncol++) Print_el(Nrow,Ncol,M[Nmat]);
    }
    printf("\nMatrix size = %d x %d\n",M[Nmat]->Num_row,M[Nmat]->Num_col);
  }
} /*Print_mat*/

Display()
{ int Nmat;
  printf("Which matrix for display = ");
  scanf("%d",&Nmat);
  Print_mat(Nmat);
} /*Display*/

XOpen()
{ int Nrow,Ncol,Nmat;
  printf("\nWhich matrix to open (0-2, -1 to quit) = ");
  scanf("%d",&Nmat);
  if (Nmat<0 || Nmat>2) return;
  printf("Enter number of rows and columns = ");
  scanf("%d %d",&Nrow,&Ncol);
  M[Nmat] = Mat_open(Nrow,Ncol);
  Print_mat(Nmat);
} /*XOpen*/

XClose()
{ int Nmat;
  printf("\nWhich matrix to close (0-2, -1 to quit) = ");
  scanf("%d",&Nmat);
  if (Nmat<0 || Nmat>2) return;
  M[Nmat] = Mat_close(M[Nmat]);
} /*XOpen*/

XPut()
{ Rtyp Re,Im;  int Col_cntr,Row_cntr,Nmat;
  printf("\nWhich matrix for put (0-2, -1 to quit) = ");
  scanf("%d",&Nmat);
  if (Nmat<0 || Nmat>2) return;
  printf("Enter -1000,-1000 to quit.\n");  Re=0.0; Im=0.0;
  for (Row_cntr=0; Row_cntr<M[Nmat]->Num_row; Row_cntr++)
    for (Col_cntr=0; Col_cntr<M[Nmat]->Num_col; Col_cntr++)
      if (Re!=-1000.0 && Im!=-1000.0)
      { printf("Row %3d, Col %3d, Enter Re,Im = ",Row_cntr,Col_cntr);
	scanf("%lf %lf",&Re,&Im);
	if (Re!=-1000.0 && Im!=-1000.0) Mat_put(Row_cntr,Col_cntr,Re,Im,M[Nmat]);
      }
  Print_mat(Nmat);
} /*XPut*/
     
XGet()
{ Rtyp Re,Im;  int ir,ic,Nmat;  char Ans;
  printf("\nWhich matrix for put (0-2, -1 to quit) = ");
  scanf("%d",&Nmat);
  if (Nmat<0 || Nmat>2) return;
  for (;;)
  { printf("Enter row, col. = ");  scanf("%d %d",&ir,&ic);
    printf("rEal, Imag, Mag, dB, Radians, Deg or Quit = ");
    while ( (Ans=getchar())<'0');
    if (Ans=='Q' || Ans=='q') break;
    switch(Ans)
    { case 'E': ; case 'e' : Re=Mat_get_re(ir,ic,M[Nmat]);  break;
      case 'I': ; case 'i' : Re=Mat_get_im(ir,ic,M[Nmat]);  break;
      case 'M': ; case 'm' : Re=Mat_get_mag(ir,ic,M[Nmat]);  break;
      case 'B': ; case 'b' : Re=Mat_get_dB(ir,ic,M[Nmat]);  break; 
      case 'R': ; case 'r' : Re=Mat_get_rad(ir,ic,M[Nmat]);  break;
      case 'D': ; case 'd' : Re=Mat_get_deg(ir,ic,M[Nmat]);  break;
    }
    printf("%8f\n",Re);
  }
} /*XGet*/

XAdd()
{ int N1,N2,N3;
  printf("\nTwo matrices to add and a third for the result = ");
  scanf("%d %d %d",&N1,&N2,&N3);
  if (N1<0 || N1>2 || N2<0 || N2>2 || N3<0 || N3>2) return;
  Mat_add(M[N1],M[N2],M[N3]);
  Print_mat(N3);
} /*XAdd*/

XSub()
{ int N1,N2,N3;
  printf("\nTwo matrices to sub and a third for the result = ");
  scanf("%d %d %d",&N1,&N2,&N3);
  if (N1<0 || N1>2 || N2<0 || N2>2 || N3<0 || N3>2) return;
  Mat_sub(M[N1],M[N2],M[N3]);
  Print_mat(N3);
} /*XSub*/

XMult()
{ int N1,N2,N3;
  printf("\nTwo matrices to mult and a third for the result = ");
  scanf("%d %d %d",&N1,&N2,&N3);
  if (N1<0 || N1>2 || N2<0 || N2>2 || N3<0 || N3>2) return;
  Print_ptrs();
  Mat_mult(M[N1],M[N2],&M[N3]);
  Print_ptrs();
  Print_mat(N3);
} /*XMult*/
  
XSadd()
{ int N1,N2;  Rtyp Re,Im;
  printf("\nMatrix for scalar add and result matrix = ");
  scanf("%d %d",&N1,&N2);
  if (N1<0 || N1>2 || N2<0 || N2>2 ) return;
  printf("Real and imag to add to matrix = ");
  scanf("%lf %lf",&Re,&Im);
  Mat_sadd(Re,Im,M[N1],M[N2]);
  Print_mat(N2);
} /*XSadd*/
  
XSsub()
{ int N1,N2;  Rtyp Re,Im;
  printf("\nMatrix for scalar sub and result matrix = ");
  scanf("%d %d",&N1,&N2);
  if (N1<0 || N1>2 || N2<0 || N2>2 ) return;
  printf("Real and imag to sub from matrix = ");
  scanf("%lf %lf",&Re,&Im);
  Mat_ssub(Re,Im,M[N1],M[N2]);
  Print_mat(N2);
} /*XSsub*/
  
XSmult()
{ int N1,N2;  Rtyp Re,Im;
  printf("\nMatrix for scalar mult and result matrix = ");
  scanf("%d %d",&N1,&N2);
  if (N1<0 || N1>2 || N2<0 || N2>2 ) return;
  printf("Real and imag to mult by matrix = ");
  scanf("%lf %lf",&Re,&Im);
  Mat_smult(Re,Im,M[N1],M[N2]);
  Print_mat(N2);
} /*XSmult*/
  
XInit()
{ int N1;  Rtyp Re,Im;
  printf("\nMatrix for init = ");
  scanf("%d",&N1);
  if (N1<0 || N1>2) return;
  printf("Real and imag to init matrix = ");
  scanf("%lf %lf",&Re,&Im);
  Mat_init(Re,Im,M[N1]);
  Print_mat(N1);
} /*XInit*/
/*

{  PROCEDURE XUnit;
    VAR
      N1 : INTEGER;
    BEGIN
      WRITE('Unitize which matrix = ');
      READLN(N1);
      IF N1 IN [1..3] THEN Mat_unit(M[N1]);
      Print_mat(M[N1]);
    END;

  PROCEDURE XTrans;
    VAR
      N1,N2 : INTEGER;
    BEGIN
      WRITE('Which matrix for transpose and which for result = ');
      READLN(N1,N2);
      IF (N1 IN [1..3]) AND (N2 IN [1..3]) THEN
        Mat_trans(M[N1],M[N2]);
      Print_mat(M[N2]);
    END;

  PROCEDURE XConj;
    VAR
      N1,N2 : INTEGER;
    BEGIN
      WRITE('Which matrix to conjugate and which for result = ');
      READLN(N1,N2);
      IF (N1 IN [1..3]) AND (N2 IN [1..3]) THEN
        Mat_conj(M[N1],M[N2]);
      Print_mat(M[N2]);
    END;

  PROCEDURE XChs;
    VAR
      N1,N2 : INTEGER;
    BEGIN
      WRITE('Which matrix to change sign and which for result = ');
      READLN(N1,N2);
      IF (N1 IN [1..3]) AND (N2 IN [1..3]) THEN
        Mat_chs(M[N1],M[N2]);
      Print_mat(M[N2]);
    END;

  PROCEDURE XDiag_add;
    VAR
      N1,N2     : INTEGER;
      Real,Imag : Rtyp;
    BEGIN
      WRITE(Real and imaginary for diagonal add = ');
      READLN(Real,Imag);
      WRITE('Which matrix for add and which for result = ');
      READLN(N1,N2);
      IF (N1 IN [1..3]) AND (N2 IN [1..3]) THEN
        Mat_diag_add(Real,Imag,M[N1],M[N2]);
      Print_mat(M[N2]);
    END;

  PROCEDURE XDiag_sub;
    VAR
      N1,N2     : INTEGER;
      Real,Imag : Rtyp;
    BEGIN
      WRITE('Real and Imaginary for diagonal subtract = ');
      READLN(Real,Imag);
      WRITE('Which matrix for subtract and which for result = ');
      READLN(N1,N2);
      IF (N1 IN [1..3]) AND (N2 IN [1..3]) THEN
        Mat_diag_sub(Re,Im,M[N1],M[N2]);
      Print_mat(M[N2]);
    END;
}
*/  
XMove()
{ int N1,N2;
  printf("\nMatrix move from and to = ");
  scanf("%d %d",&N1,&N2);
  if (N1<0 || N1>2 || N2<0 || N2>2 ) return;
  Mat_move(M[N1],M[N2]);
  Print_mat(N2);
} /*XMove*/

XInvert()
{ int N1;
  printf("\nMatrix for invert = ");
  scanf("%d",&N1);
  if (N1<0 || N1>2) return;
  Mat_inv(M[N1]);
  Print_mat(N1);
} /*XInvert*/

XRed()
{ int N1,N2;
  printf("\nMatrix for reduction = ");
  scanf("%d",&N1);
  if (N1<0 || N1>2) return;
  printf("Reduce to what order = ");
  scanf("%d",&N2);
  Mat_red(N2,M[N1],0);
  Print_mat(N1);
} /*XRed*/

Xlud()
{ int N1,N2,N3,i,ii,j;
  Mat_ptr result;
  Ssmat_ptr S;
  printf("\nMatrix for LU Decomposition = ");
  scanf("%d",&N1);
  if (N1<0 || N1>2) return;
  printf("Solve to what order = ");
  scanf("%d",&N2);
  N3 = M[N1]->Num_row;
  S = Ssmat_open(N3,0);  Ssmat_re(S);  Ssmat_im(S);
  for (ii=i=0; i<N3; i++) for (j=i; j<N3; j++)
  { *(S->re+ii) = Mat_get_re(i,j,M[N1]);
    *(S->im+ii) = Mat_get_im(i,j,M[N1]);
    ii++;
  }
  result = Ssmat_lud(S,N2);
  for (i=0; i<N2; i++) for (j=0; j<N2; j++)
    Mat_put(i,j,Mat_get_re(i,j,result),Mat_get_im(i,j,result),M[N1]);
  Mat_close(result);  Ssmat_close(S);
  Print_mat(N1);
} /*Xlud*/

XGrad()
{ int N1,N2,i,j;
  Mat_ptr result;
  printf("\nMatrix for solve = ");
  scanf("%d",&N1);
  if (N1<0 || N1>2) return;
  printf("Solve to what order = ");
  scanf("%d",&N2);
  result = Mat_grad(N2,M[N1],1.0e-8);
  for (i=0; i<N2; i++) for (j=0; j<N2; j++)
    Mat_put(i,j,Mat_get_re(i,j,result),Mat_get_im(i,j,result),M[N1]);
  Mat_close(result);
  Print_mat(N1);
} /*XGrad*/
